package com.prolog.eis.service.out.impl;

import com.prolog.eis.dao.out.BizOutboundTaskDismantleSupplyMapper;
import com.prolog.eis.model.out.BizOutboundTaskDismantleSupply;
import com.prolog.eis.service.out.BizOutboundTaskDismantleSupplyService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库任务拆零待补货数量-服务实现类
 * @date 2023-09-20 18:32
 */
@Service
public class BizOutboundTaskDismantleSupplyServiceImpl implements BizOutboundTaskDismantleSupplyService {

    @Autowired
    private BizOutboundTaskDismantleSupplyMapper bizOutboundTaskDismantleSupplyMapper;

    /**
     * 新增数据
     *
     * @param bizOutboundTaskDismantleSupply 出库任务拆零待补货数量
     */
    @Override
    public long save(BizOutboundTaskDismantleSupply bizOutboundTaskDismantleSupply) {
        return bizOutboundTaskDismantleSupplyMapper.save(bizOutboundTaskDismantleSupply);
    }

    /**
     * 新增批量数据
     *
     * @param bizOutboundTaskDismantleSupplyList 出库任务拆零待补货数量
     */
    @Override
    public long saveBatch(List<BizOutboundTaskDismantleSupply> bizOutboundTaskDismantleSupplyList) {
        return bizOutboundTaskDismantleSupplyMapper.saveBatch(bizOutboundTaskDismantleSupplyList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDismantleSupply> findByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDismantleSupplyMapper.findByMap(paramMap, BizOutboundTaskDismantleSupply.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public BizOutboundTaskDismantleSupply findOneByMap(Map<String, Object> paramMap) {
        List<BizOutboundTaskDismantleSupply> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<BizOutboundTaskDismantleSupply> findByCriteria(Criteria criteria) {
        return bizOutboundTaskDismantleSupplyMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public BizOutboundTaskDismantleSupply findById(int id) {
        return bizOutboundTaskDismantleSupplyMapper.findById(id, BizOutboundTaskDismantleSupply.class);
    }

    /**
     * 修改数据
     *
     * @param bizOutboundTaskDismantleSupply 实例对象
     */
    @Override
    public long update(BizOutboundTaskDismantleSupply bizOutboundTaskDismantleSupply) {
        return bizOutboundTaskDismantleSupplyMapper.update(bizOutboundTaskDismantleSupply);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return bizOutboundTaskDismantleSupplyMapper.deleteById(id, BizOutboundTaskDismantleSupply.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDismantleSupplyMapper.deleteByMap(paramMap, BizOutboundTaskDismantleSupply.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return bizOutboundTaskDismantleSupplyMapper.findCountByMap(paramMap, BizOutboundTaskDismantleSupply.class);
    }
}
